=== debian/changelog ===
ros-kinetic-plotjuggler (2.8.3-1xenial) xenial; urgency=high

  * more memes
  * "New versione vailable" improved
  * fix segmentation fault when tryin reconnect to ROS master
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Fri, 10 Jul 2020 22:00:00 -0000

ros-kinetic-plotjuggler (2.8.2-1xenial) xenial; urgency=high

  * might fix issue #301 <https://github.com/facontidavide/PlotJuggler/issues/301>
  * fix warnings
  * fix potential mutex problem related to #300 <https://github.com/facontidavide/PlotJuggler/issues/300>
  * bug fix
  * Update package.xml
  * updated gif
  * cherry picking changes from #290 <https://github.com/facontidavide/PlotJuggler/issues/290>
  * fix #296 <https://github.com/facontidavide/PlotJuggler/issues/296>
  * fix issues on windows Qt 5.15
  * fix error
  * move StatePublisher to tf2
  * revert changes
  * fix warnings
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 06 Jul 2020 22:00:00 -0000

ros-kinetic-plotjuggler (2.8.1-1xenial) xenial; urgency=high

  * fix critical bug in streaming ROS plugin
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 27 May 2020 22:00:00 -0000

ros-kinetic-plotjuggler (2.8.0-1xenial) xenial; urgency=high

  * Update CMakeLists.txt
  * Added graph context menu description (#288 <https://github.com/facontidavide/PlotJuggler/issues/288>)
  * Update FUNDING.yml
  * Merge branch 'master' of https://github.com/facontidavide/PlotJuggler
  * finished with refactoring
  * WIP: re publisher ROS2
  * added stuff to dataload_ros2
  * Update appimage_howto.md
  * fix package name
  * embrace pj_msgs (https://github.com/facontidavide/plotjuggler_msgs)
  * new clang format and fix in header_stamp usage
  * removed marl and rule editing
  * more parsers added
  * more or less working
  * save computation like a champ with plot_data in each parser
  * precompute strings only once
  * fix compilation on ROS1
  * Merge branch 'master' of https://github.com/facontidavide/PlotJuggler
  * builtin parsers added
  * Githug actions win (#284 <https://github.com/facontidavide/PlotJuggler/issues/284>)
    * try compiling on windows
    * Update windows.yaml
    * multiple workflows
    * Update README.md
    Co-authored-by: mailto:daf@blue-ocean-robotics.com <Davide Faconti>
  * bug fix
  * segfault fixed in TypeHasHeader
  * removed rosdep of pj_msgs
  * added pj_msgs to ROS2
  * fix errors
  * heavy refactoring of ROS2 plugins
  * critical bug fix in ROS2 parsing
  * try to fix problem with StringTreeLeaf::toStr
  * reduce a bit allocations overhead
  * reduce memory used by the job queue of marl, with periodic flushes
  * Contributors: Davide Faconti, Ilya Petrov

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 23 May 2020 22:00:00 -0000

ros-kinetic-plotjuggler (2.7.0-1xenial) xenial; urgency=high

  * Merge branch 'ros2' of https://github.com/facontidavide/PlotJuggler into ros2
  * added github actions for ros2
  * last fixes to DataStreamROS2
  * implemented DataLoadRosBag2
  * compile with ament/colcon
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 02 May 2020 22:00:00 -0000

ros-kinetic-plotjuggler (2.6.4-1xenial) xenial; urgency=high

  * Fix the damn icons
  * marl updated
  * fix issue #281 <https://github.com/facontidavide/PlotJuggler/issues/281>
  * catch exception in marl
  * fix backward-cpp
  * Implement feature #274 <https://github.com/facontidavide/PlotJuggler/issues/274>
  * Implement feature #269 <https://github.com/facontidavide/PlotJuggler/issues/269>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 29 Apr 2020 22:00:00 -0000

ros-kinetic-plotjuggler (2.6.3-1xenial) xenial; urgency=high

  * Fix issue #271 <https://github.com/facontidavide/PlotJuggler/issues/271>
  * @veimox added
  * Bugfix/executable (#264 <https://github.com/facontidavide/PlotJuggler/issues/264>)
    * created launching script , installing and making use of it in the icon
    * ignoring temporary folders when creating binary locally
    * corrected intsallation of script
    * using PROGRAM to install it with executable permissions
    Co-authored-by: Jorge Rodriguez <mailto:jr@blue-ocean-robotics.com>
  * Feature/scalable icon (#265 <https://github.com/facontidavide/PlotJuggler/issues/265>)
    * installing icons in /usr/share and do it at any build type
    * added scalable icon
    * removed old icon
    Co-authored-by: Jorge Rodriguez <mailto:jr@blue-ocean-robotics.com>
  * fix default suffix
  * Fix bug #258 <https://github.com/facontidavide/PlotJuggler/issues/258>
  * Contributors: Davide Faconti, Jorge Rodriguez

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 06 Apr 2020 22:00:00 -0000

ros-kinetic-plotjuggler (2.6.2-1xenial) xenial; urgency=high

  * bug fix in IMU parser
  * added step size for the time tracker
  * fis issue #256 <https://github.com/facontidavide/PlotJuggler/issues/256> (new release dialog)
  * Update README.md
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Mon, 24 Feb 2020 23:00:00 -0000

ros-kinetic-plotjuggler (2.6.1-1xenial) xenial; urgency=high

  * fix issue #253 <https://github.com/facontidavide/PlotJuggler/issues/253> and some cleanup
  * fix issue #254 <https://github.com/facontidavide/PlotJuggler/issues/254>
  * Fix #251 <https://github.com/facontidavide/PlotJuggler/issues/251>
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Thu, 20 Feb 2020 23:00:00 -0000

ros-kinetic-plotjuggler (2.6.0-1xenial) xenial; urgency=high

  * bug fix
  * fix splashscreen delay
  * GUI refinement
  * regex filter removed. bug fix in column resize
  * new icons in CurveList panel
  * add text placeholder
  * smaller buttons
  * moved buttons to top right corner to gain more space
  * changed style (sharper corners)
  * bug fix: potential crash trying to save data into rosbag

