=== debian/control ===
Source: ros-kinetic-plotjuggler
Section: misc
Priority: optional
Maintainer: Davide Faconti <davide.faconti@gmail.com>
Build-Depends: debhelper (>= 9.0.0), binutils-dev, libboost-all-dev, libqt5multimedia5-plugins, libqt5svg5-dev, qtbase5-dev, qtdeclarative5-dev, qtmultimedia5-dev, ros-kinetic-catkin, ros-kinetic-diagnostic-msgs, ros-kinetic-geometry-msgs, ros-kinetic-nav-msgs, ros-kinetic-plotjuggler-msgs, ros-kinetic-rosbag-storage, ros-kinetic-roscpp, ros-kinetic-roscpp-serialization, ros-kinetic-sensor-msgs, ros-kinetic-tf, ros-kinetic-tf2-msgs, ros-kinetic-tf2-ros
Homepage: https://github.com/facontidavide/PlotJuggler
Standards-Version: 3.9.2

Package: ros-kinetic-plotjuggler
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils-dev, libboost-all-dev, libqt5multimedia5-plugins, libqt5svg5-dev, qtbase5-dev, qtdeclarative5-dev, qtmultimedia5-dev, ros-kinetic-diagnostic-msgs, ros-kinetic-geometry-msgs, ros-kinetic-nav-msgs, ros-kinetic-plotjuggler-msgs, ros-kinetic-rosbag-storage, ros-kinetic-roscpp, ros-kinetic-roscpp-serialization, ros-kinetic-sensor-msgs, ros-kinetic-tf, ros-kinetic-tf2-msgs, ros-kinetic-tf2-ros
Description: PlotJuggler: juggle with data
